// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from fuse_msgs:msg/SerializedGraph.idl
// generated code does not contain a copyright notice

#ifndef FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__STRUCT_HPP_
#define FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__fuse_msgs__msg__SerializedGraph __attribute__((deprecated))
#else
# define DEPRECATED__fuse_msgs__msg__SerializedGraph __declspec(deprecated)
#endif

namespace fuse_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SerializedGraph_
{
  using Type = SerializedGraph_<ContainerAllocator>;

  explicit SerializedGraph_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->plugin_name = "";
    }
  }

  explicit SerializedGraph_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    plugin_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->plugin_name = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _plugin_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _plugin_name_type plugin_name;
  using _data_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__plugin_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->plugin_name = _arg;
    return *this;
  }
  Type & set__data(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    fuse_msgs::msg::SerializedGraph_<ContainerAllocator> *;
  using ConstRawPtr =
    const fuse_msgs::msg::SerializedGraph_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::msg::SerializedGraph_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      fuse_msgs::msg::SerializedGraph_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__fuse_msgs__msg__SerializedGraph
    std::shared_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__fuse_msgs__msg__SerializedGraph
    std::shared_ptr<fuse_msgs::msg::SerializedGraph_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SerializedGraph_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->plugin_name != other.plugin_name) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const SerializedGraph_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SerializedGraph_

// alias to use template instance with default allocator
using SerializedGraph =
  fuse_msgs::msg::SerializedGraph_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace fuse_msgs

#endif  // FUSE_MSGS__MSG__DETAIL__SERIALIZED_GRAPH__STRUCT_HPP_
